unit QDRDockEditor;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QDRToolbar, DesignIntf, DesignEditors;

type
  TDRDockEditorForm = class(TForm)
    FloatingC: TCheckBox;
    Label1: TLabel;
    AlignC: TComboBox;
    OkB: TButton;
    CancelB: TButton;
  private
    { Private declarations }
  public
    { Public declarations }
    Dock: TDRDock;
  end;

  TDRDockEditor = class(TComponentEditor)
  public
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): string; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;

var
  DRDockEditorForm: TDRDockEditorForm;

function EditDRDock(aDock: TDRDock): boolean;

procedure Register;

implementation


{$R *.xfm}

procedure Register;
begin
  RegisterComponentEditor(TDRDock, TDRDockEditor);
end;

function EditDRDock(aDock: TDRDock): boolean;
begin
  DRDockEditorForm := TDRDockEditorForm.Create(Application);
  try
    with DRDockEditorForm do begin
      Dock := aDock;

      AlignC.ItemIndex := ord(aDock.DockAlign);
      FloatingC.Checked := aDock.AllowFloating;

      Result := ShowModal = mrOk;
      if Result then begin
        aDock.DockAlign := TDRDockAlign(AlignC.ItemIndex);
        aDock.AllowFloating := FloatingC.Checked;
      end;
    end;
  finally
    DRDockEditorForm.Free;
  end;
end;

{ TDRDockEditor }

procedure TDRDockEditor.ExecuteVerb(Index: Integer);
begin
  // inherited;
  if EditDRDock(TDRDock(Component)) then
    Designer.Modified;
end;

function TDRDockEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := 'Dock &Editor';
    else ;
  end;
end;

function TDRDockEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

end.
