unit QCLXItemEditor;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QCLXToolbar, DesignIntf, DesignEditors, QExtCtrls,
  QButtons;

type
  TCLXItemEditorForm = class(TForm)
    Panel1: TPanel;
    BNewCategory: TSpeedButton;
    Panel2: TPanel;
    Label1: TLabel;
    BClose: TSpeedButton;
    Label2: TLabel;
    CategoriesLB: TListBox;
    ItemsLB: TListBox;
    procedure BCloseClick(Sender: TObject);
    procedure CategoriesLBClick(Sender: TObject);
  private
    { Private declarations }
    FManager: TCLXItemManager;
  public
    { Public declarations }
    procedure RefreshCategories;
    procedure RefreshItems;
  end;

  TCLXItemEditor = class(TComponentEditor)
  public
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): string; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;

var
  CLXItemEditorForm: TCLXItemEditorForm;
//  FManager: TDRItemManager;

function EditDRItem(AItem: TCLXItemManager): boolean;

procedure Register;

implementation

{$R *.xfm}

procedure Register;
begin
  RegisterComponentEditor(TCLXItemManager, TCLXItemEditor);
end;

function EditDRItem(AItem: TCLXItemManager): boolean;
begin
  CLXItemEditorForm := TCLXItemEditorForm.Create(Application);
  try
    CLXItemEditorForm.FManager := AItem;
    CLXItemEditorForm.RefreshCategories;
//    CLXItemEditorForm.RefreshItems;
    Result := CLXItemEditorForm.ShowModal = mrOk;
  finally
    CLXItemEditorForm.Free;
  end;
end;

{ TCLXItemEditor }

procedure TCLXItemEditor.ExecuteVerb(Index: Integer);
begin
  inherited;
  if EditDRItem(TCLXItemManager(Component)) then
    Designer.Modified;
end;

function TCLXItemEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := 'Items &Editor';
    else ;
  end;
end;

function TCLXItemEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

procedure TCLXItemEditorForm.BCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TCLXItemEditorForm.RefreshCategories;
var I: Integer;
begin
//ShowMessage('Categories.Count = '+IntToStr(FManager.Categories.Count));
  CategoriesLB.Items.Clear;
  for I := 0 to pred(FManager.Categories.Count) do
    CategoriesLB.Items.Add(FManager.Categories[I].Caption);
end;

procedure TCLXItemEditorForm.RefreshItems;
var I, J: Integer;
    ACategory: TCLXCategory;
    AItem: TCLXCustomItem;
    S: string;
begin
  ItemsLB.Items.Clear;
  J := CategoriesLB.ItemIndex;
  if J < 0 then exit;

  ACategory := TCLXCategory(FManager.Categories.Items[J]);
ShowMessage('ACategory.Caption = ' + ACategory.Caption);
//ShowMessage('Items.Count = '+IntToStr(ACategory.CategoryItems.Count));
  for I := 0 to pred(ACategory.CategoryItems.Count) do
  begin
if ACategory.CategoryItems.Items[I] = nil then
ShowMessage('AItem = nil');
AItem := ACategory.CategoryItems.Items[I];
//if AItem = nil then
//ShowMessage('AItem = nil');
ShowMessage('Item no. = '+IntToStr(I));
//S := ACategory.CategoryItems.Items[I].Caption;
//S := ACategory.CategoryItems.Items[I].Category;
S := 'ClassName = ' + AItem.ClassName;
//ShowMessage('After assignation');
ShowMessage(S);
    ItemsLB.Items.Add(ACategory.CategoryItems.Items[I].Caption);
  end;
end;

procedure TCLXItemEditorForm.CategoriesLBClick(Sender: TObject);
begin
  RefreshItems;
end;

end.
