unit QDRItemEditor;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QDRToolbar, DesignIntf, DesignEditors, QExtCtrls,
  QButtons;

type
  TDRItemEditorForm = class(TForm)
    Panel1: TPanel;
    BNewCategory: TSpeedButton;
    Panel2: TPanel;
    Label1: TLabel;
    BClose: TSpeedButton;
    Label2: TLabel;
    CategoriesLB: TListBox;
    ItemsLB: TListBox;
    procedure BCloseClick(Sender: TObject);
    procedure CategoriesLBClick(Sender: TObject);
  private
    { Private declarations }
    FManager: TDRItemManager;
  public
    { Public declarations }
    procedure RefreshCategories;
    procedure RefreshItems;
  end;

  TDRItemEditor = class(TComponentEditor)
  public
    function GetVerbCount: Integer; override;
    function GetVerb(Index: Integer): string; override;
    procedure ExecuteVerb(Index: Integer); override;
  end;

var
  DRItemEditorForm: TDRItemEditorForm;
//  FManager: TDRItemManager;

function EditDRItem(AItem: TDRItemManager): boolean;

procedure Register;

implementation

{$R *.xfm}

procedure Register;
begin
  RegisterComponentEditor(TDRItemManager, TDRItemEditor);
end;

function EditDRItem(AItem: TDRItemManager): boolean;
begin
  DRItemEditorForm := TDRItemEditorForm.Create(Application);
  try
    DRItemEditorForm.FManager := AItem;
    DRItemEditorForm.RefreshCategories;
//    DRItemEditorForm.RefreshItems;
    Result := DRItemEditorForm.ShowModal = mrOk;
  finally
    DRItemEditorForm.Free;
  end;
end;

{ TDRItemEditor }

procedure TDRItemEditor.ExecuteVerb(Index: Integer);
begin
  inherited;
  if EditDRItem(TDRItemManager(Component)) then
    Designer.Modified;
end;

function TDRItemEditor.GetVerb(Index: Integer): string;
begin
  case Index of
    0: Result := 'Items &Editor';
    else ;
  end;
end;

function TDRItemEditor.GetVerbCount: Integer;
begin
  Result := 1;
end;

procedure TDRItemEditorForm.BCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TDRItemEditorForm.RefreshCategories;
var I: Integer;
begin
//ShowMessage('Categories.Count = '+IntToStr(FManager.Categories.Count));
  CategoriesLB.Items.Clear;
  for I := 0 to pred(FManager.Categories.Count) do
    CategoriesLB.Items.Add(FManager.Categories[I].Caption);
end;

procedure TDRItemEditorForm.RefreshItems;
var I, J: Integer;
    ACategory: TDRCategory;
    AItem: TDRCustomItem;
    S: string;
begin
  ItemsLB.Items.Clear;
  J := CategoriesLB.ItemIndex;
  if J < 0 then exit;

  ACategory := TDRCategory(FManager.Categories.Items[J]);
ShowMessage('ACategory.Caption = ' + ACategory.Caption);
//ShowMessage('Items.Count = '+IntToStr(ACategory.CategoryItems.Count));
  for I := 0 to pred(ACategory.CategoryItems.Count) do
  begin
if ACategory.CategoryItems.Items[I] = nil then
ShowMessage('AItem = nil');
AItem := ACategory.CategoryItems.Items[I];
//if AItem = nil then
//ShowMessage('AItem = nil');
ShowMessage('Item no. = '+IntToStr(I));
//S := ACategory.CategoryItems.Items[I].Caption;
//S := ACategory.CategoryItems.Items[I].Category;
S := 'ClassName = ' + AItem.ClassName;
//ShowMessage('After assignation');
ShowMessage(S);
    ItemsLB.Items.Add(ACategory.CategoryItems.Items[I].Caption);
  end;
end;

procedure TDRItemEditorForm.CategoriesLBClick(Sender: TObject);
begin
  RefreshItems;
end;

end.
